import java.awt.*;
import java.awt.event.*;

class AwtC
{
    public static void main(String[] arg)
	{
        Frame win = new Frame("Window 1");
        win.addWindowListener(new WindowListenerB());
        win.setVisible(true);
    	
		win = new Frame("Window 2");
    	win.addWindowListener(new WindowAdapterC());
    	win.setVisible(true);
    }
}


// ŧih methods  Listener {]p̰i Adapter
class WindowAdapterC extends WindowAdapter 
{
    public void windowClosing(WindowEvent e)
	{
    	e.getWindow().dispose();
    }
    
	public void windowClosed(WindowEvent e) 
	{
        System.out.println(WindowListenerB.threadName() 
              + ": " + ((Frame)e.getSource()).getTitle() 
              + " is closed");
    }
}


class WindowListenerB implements WindowListener 
{
    public void windowActivated(WindowEvent e) {
        System.out.println(threadName() + ": Activated");
    }
    public void windowDeactivated(WindowEvent e) {
        System.out.println(threadName() + ": Deactivated");
    }
    public void windowIconified(WindowEvent e) {
        System.out.println(threadName() + ": Iconified");
    }
    public void windowDeiconified(WindowEvent e) {
        System.out.println(threadName() + ": Deiconified");
    }
    public void windowOpened(WindowEvent e) {
        System.out.println(threadName() + ": Opened");
    }
    public void windowClosed(WindowEvent e) {
        System.out.println(threadName() + ": Closed");
    }
    public void windowClosing(WindowEvent e) {
        System.out.println(threadName() + ": Closing");
    }
    public static String threadName() {
        return Thread.currentThread().getName();	
    }
}


// Event adapter class              implements interface
//-------------------------------------------------------
// WindowAdapter					WindowListener
// ComponentAdapter					ComponentListener
// ComtainerAdapter					ComtainerListener
// FocusAdapter						FocusListener
// KeyAdapter						KeyListener
// MouseAdapter						MouseListener
// MouseMotionAdapter				MouseMotionListener
