import java.awt.*;
import java.awt.event.*;

class AwtB
{
    public static void main(String[] arg)
	{
        Frame win = new Frame();
		//for processing window events
        win.addWindowListener(new WindowListenerB());
        win.setVisible(true);
        System.out.println(WindowListenerB.threadName()
                           + ": I am dying.");
    }
}

class WindowListenerB implements WindowListener
{
    public void windowActivated(WindowEvent e) {
        System.out.println(threadName() + ": Activated");
    }
    public void windowDeactivated(WindowEvent e) {
        System.out.println(threadName() + ": Deactivated");
    }
    public void windowIconified(WindowEvent e) {
        System.out.println(threadName() + ": Iconified");
    }
    public void windowDeiconified(WindowEvent e) {
        System.out.println(threadName() + ": Deiconified");
    }
    public void windowOpened(WindowEvent e) {
        System.out.println(threadName() + ": Opened");
    }
    public void windowClosed(WindowEvent e) {
        System.out.println(threadName() + ": Closed");
    }
    public void windowClosing(WindowEvent e) {
        System.out.println(threadName() + ": Closing");
    }
    public static String threadName() {
        return Thread.currentThread().getName();	
    }
}

// java.lang.Object
//     java.util.EventObject
//         java.awt.AwtEvent
//             java.awt.event.xxxEvent
// java.util.EventListener (interface)
//     java.awt.event.xxxListener (interface)
// java.lang.Object
//     java.awt.event.xxxAdaptor (implements xxxListener)

// interface WindowListener ŧiF 7  methods

//  event tΩhwB{]p̥[JB~Apṳjơv
//  event tΩhSA{]p̻ݥ[JB~Apuv
//  event tΩhw{]p̥[JB~Apṳpơv

// Window 󦳤@ instance variable s windowListener
// WindowEvent 󦳤@ instance variable s sourceAŧib EventObject

// AWT_EventQueue-0
//   @ Event 
//   d sourceADO Window 
//   䥦 windowListenerAA method Bz@ Event
