import java.awt.*;
import java.awt.event.*;

class AwtF extends Frame
{
    public static void main(String[] arg)
	{
        new AwtF();
    }
    
	TextField t;
    
    AwtF()
	{
        addWindowListener(new WindowAdapterF());
        setVisible(true);
        t = new TextField(40);
        add("North", t);
        Button b = new Button("Clear");
        add("South", b);
        b.addActionListener(new ActionListenerF());
        pack();
    }
    
	//inner class
	class ActionListenerF implements ActionListener
	{
        public void actionPerformed(ActionEvent e) {
            t.setText("");  
        }
    }
}

class WindowAdapterF extends WindowAdapter
{
    public void windowClosing(WindowEvent e)
	{
    	System.exit(0);
    }
}

// inner class
// I am within the scope of "t", so I can access "t" directly

// An inner class object is allow to access directly all the variables
// and methods (members) of the outer class object that define it.