import java.io.*;					// standard java graphics imports
import java.util.*;
import java.awt.*;
import java.awt.event.*;


class AwtI extends Frame implements ActionListener, MouseListener
{
	int X=0, Y=0;
	int x1=0, y1=0;
	int x2=0, y2=0;
	MenuItem exit;
	
	//constructor
	public AwtI()
	{
		super("AwtI");
		setSize(400,400);
		
		//create and add menu
		MenuBar menubar=new MenuBar();
		setMenuBar(menubar);
	    Menu file =new Menu("FILE"); 
		exit = new MenuItem("EXIT");
		file.add(exit);
		menubar.add(file);
		
		//add Listeners to components
		exit.addActionListener(this);
		addMouseListener(this);
	    addWindowListener(new WindowAdapter()
		{
			public void windowClosing(WindowEvent e)
			{
				 System.exit(0);
			}
		});
	}

	//paint
	public void paint(Graphics g)
	{
		g.setColor(Color.black);
		g.drawLine(X-5, Y+5, X+5, Y-5);
		g.drawLine(X-5, Y-5, X+5, Y+5);
		g.drawLine(x1, y1, x2, y2);

		g.setColor(Color.red);
		g.drawLine(5, 55, 350, 55);
		g.drawString(X+ " " +Y, 350, 60);
		
		g.setColor(Color.blue);
		g.drawRect(5, 60, 90, 55);
		g.fillRect(100, 60, 90, 55);
		
		g.setColor(Color.cyan);
		g.fillRoundRect(195, 60, 90, 55, 50, 50);
		g.drawRoundRect(290, 60, 90, 55, 20, 20);

		g.setColor(Color.yellow);
		g.draw3DRect(5, 120, 90, 55, true);
		g.fill3DRect(100, 120, 90, 55, false);

		g.setColor(Color.magenta);
		g.drawOval(195, 120, 90, 55);
		g.fillOval(290, 120, 90, 55);
	}
		
	//implements ActionListener, MouseListener
	public void actionPerformed(ActionEvent e)
	{
		if(e.getSource() == exit)
		{
			 System.exit(0);
		}
	}
	
	//implements MouseListener
	public void mouseClicked(MouseEvent e)
	{
		X = e.getX();
		Y = e.getY();
		System.out.println(X+ " " +Y);
		repaint();

	}
	
	public void mouseEntered(MouseEvent e)
	{
		
	}
	public void mouseExited(MouseEvent e)
	{
		
	}
	public void mousePressed(MouseEvent e)
	{
		x1 = e.getX();
		y1 = e.getY();
	}
	public void mouseReleased(MouseEvent e)
	{
		x2 = e.getX();
		y2 = e.getY();		
		repaint();
	}
	
	//main
	public static void main( String args[] ) 
	{
		AwtI w = new AwtI();
		w.setVisible(true);	
	}
}